;---
;- 2xMPT 8Channel Stereo Project
;- 18.01.2004 by TeBe / Madteam
;---

iocb equ $340
ciov equ $e456

 org $a000

main ldy #8
 lda #0
clr sta $d200,y
 sta $d210,y
 dey
 bpl clr
 lda #3
 sta $d20f
 sta $d21f

; jsr $f21e

 ldx <txt
 ldy >txt
 jsr pokaz

;---
;- zaladowanie 1-ego pliku MPT

first ldx <get1
 ldy >get1
 jsr pokaz

;- pobranie nazwy 1-ego pliku
 jsr getName

 ldx #$10
 ldy #4
 lda #3
 jsr open

 ldx <tmp
 ldy >tmp
 jsr a_adr
 ldx <6
 ldy >6
 jsr a_len
 lda #7
 ldx #$10
 jsr read
 
 lda tmp+2
 cmp <$2000
 bne err20
 lda tmp+3
 cmp >$2000
 bne err20
  
 ldx <$2000
 ldy >$2000
 jsr a_adr
 ldx <$4000
 ldy >$4000
 jsr a_len
 lda #7
 ldx #$10
 jsr read

 ldx #$10
 jsr clos

;---
;- zaladowanie 2-ego pliku MPT

second ldx <get2
 ldy >get2
 jsr pokaz

;- pobranie nazwy 2-ego pliku
 jsr getName

 ldx #$10
 ldy #4
 lda #3
 jsr open

 ldx <tmp
 ldy >tmp
 jsr a_adr
 ldx <6
 ldy >6
 jsr a_len
 lda #7
 ldx #$10
 jsr read
 
 lda tmp+2
 cmp <$6000
 bne err60
 lda tmp+3
 cmp >$6000
 bne err60
  
 ldx <$6000
 ldy >$6000
 jsr a_adr
 ldx <$4000
 ldy >$4000
 jsr a_len
 lda #7
 ldx #$10
 jsr read

 ldx #$10
 jsr clos
 jmp play

;---
err20 ldx <er20
 ldy >er20
 jsr pokaz
 ldx #$10
 jsr clos
 jmp first

err60 ldx <er60
 ldy >er60
 jsr pokaz
 ldx #$10
 jsr clos
 jmp second
;---

play jsr play1+3
 jsr play2+3
 ldx <ply
 ldy >ply
 jsr pokaz

loop lda 20
 cmp 20
 beq *-2

 jsr play1
 jsr play2
 
 lda $d20f
 and #4
 beq stop 
 jmp loop

stop jmp main 

open sty k_op+1
 sta iocb+2,x
 lda <nam
 sta iocb+4,x
 lda >nam
 sta iocb+5,x
k_op lda #4
 sta iocb+$a,x
 jsr ciov
 bmi error
 rts

a_adr stx l_adr+1
 sty h_adr+1
 rts

a_len stx l_len+1
 sty h_len+1
 rts

read sta iocb+2,x
l_adr lda #0
 sta iocb+4,x
h_adr lda #0
 sta iocb+5,x
l_len lda #0
 sta iocb+8,x
h_len lda #0
 sta iocb+9,x
 jsr ciov
 bmi error
 rts

clos lda #$c
 sta iocb+2,x
 jsr ciov
 bmi error
 rts

error cpy #136
 beq OK

 :2 pla
 lda #$c
 ldx #$10
 sta iocb+2,x
 jsr ciov
 ldx <err
 ldy >err
 jsr pokaz 
 jmp main
 
OK rts
 
getName lda #0
 sta adr+1
get jsr $f24a
adr ldx #0 
 sta nam,x
 cmp #$9b
 beq over
 
 inx
 stx adr+1
 cpx #15
 bne  get
over rts

;---
pokaz stx rX+1
 sty rY+1
 lda #$9b
 jsr $f2b0
rX ldx #0
rY ldy #0
 jsr $c642
  rts
;---

txt dta c' 2xMPT 8Channel Stereo Project v1.0   '
    dta c'idea: Slaves/TQA, code: TeBe/Madteam',b($9b)

get1 dta c'Loading first MPT file ($2000)',b($9b)
get2 dta c'Loading second MPT file ($6000)',b($9b)
err  dta c'I/O error',b($9b)

er20 dta c'Run adres <> $2000',b($9b)
er60 dta c'Run adres <> $6000',b($9b)

ply  dta c'Playing in stereo (any key to quit)',b($9b)

tmp org *+6

;---
;---
 org $0600
nam org *+32

 org $a400
play1 ins 'mpt_1.obx'

 org $a900
play2 ins 'mpt_2.obx'

 run main